from infi.shell.commands import commandgroup, command, render

from .types import Enclosure
from . import superuser

QUERY_FORCED = ["id"]
QUERY_ORDER = ["id", "state", "vendor", "model", "revision", "firmware"]
QUERY_EXCLUDED = ["STATE_DESCRIPTION"]
QUERY_SUBSTITUTES = dict(
    id="index",
    drives_number="drives",
    )

@commandgroup(prefix="enclosure")
class EnclosureCommands(object):
    @superuser
    @command
    @render(order=QUERY_ORDER,
            forced=QUERY_FORCED,
            excluded=QUERY_EXCLUDED,
            substitute=QUERY_SUBSTITUTES)
    def query(self, _api):
        return Enclosure.iter_all(_api, hook=self._query_hook)
    def _query_hook(self, enclosures):
        for e in enclosures:
            del e["drives"]
        return enclosures
